'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('@react2rx/core');
var router = require('@react2rx/router');
var react = require('react');
var client = require('react-dom/client');
var config = require('@react2rx/bootstrap/config');
var logger = require('@react2rx/bootstrap/logger');
var persistence = require('@react2rx/persistence');
var jsxRuntime = require('react/jsx-runtime');

var applyMiddlewares = function applyMiddlewares(so$) {
  var middlewares = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (process.env.NODE_ENV !== "production") {
    middlewares.push( /*#__PURE__*/logger.createLogger());
  }
  so$.applyMiddleware(...middlewares);
};
var createBootstrap = config$1 => function (e) {
  for (var _len = arguments.length, middlewares = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    middlewares[_key - 1] = arguments[_key];
  }
  // eslint-disable-next-line
  console.log(config$1);
  var persistence$1 = /*#__PURE__*/persistence.persistence(config$1.appName || "app");
  return function ($root) {
    var strictMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var r = /*#__PURE__*/client.createRoot($root);
    var storeValue = /*#__PURE__*/persistence$1.hydrate();
    var store$ = /*#__PURE__*/core.Store.create(storeValue);
    applyMiddlewares(store$, middlewares);
    var app = /*#__PURE__*/jsxRuntime.jsx(core.StoreProvider, {
      value: store$,
      children: /*#__PURE__*/jsxRuntime.jsxs(config.ConfigProvider, {
        value: {
          config: config$1
        },
        children: [/*#__PURE__*/jsxRuntime.jsx(persistence.PersistenceConnect, {
          persistence: persistence$1
        }), /*#__PURE__*/jsxRuntime.jsx(router.React2rxRouter, {
          basename: config$1.basename,
          children: typeof e === "function" ? e() : e
        })]
      })
    });
    if (strictMode) {
      r.render( /*#__PURE__*/jsxRuntime.jsx(react.StrictMode, {
        children: app
      }));
    } else {
      r.render(app);
    }
  };
};

exports.createBootstrap = createBootstrap;
