import { StoreProvider, Store } from '@react2rx/core';
import { React2rxRouter } from '@react2rx/router';
import { StrictMode } from 'react';
import { createRoot } from 'react-dom/client';
import { ConfigProvider } from '@react2rx/bootstrap/config';
import { createLogger } from '@react2rx/bootstrap/logger';
import { persistence, PersistenceConnect } from '@react2rx/persistence';
import { jsx, jsxs } from 'react/jsx-runtime';

var applyMiddlewares = function applyMiddlewares(so$) {
  var middlewares = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (process.env.NODE_ENV !== "production") {
    middlewares.push( /*#__PURE__*/createLogger());
  }
  so$.applyMiddleware(...middlewares);
};
var createBootstrap = config => function (e) {
  for (var _len = arguments.length, middlewares = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    middlewares[_key - 1] = arguments[_key];
  }
  // eslint-disable-next-line
  console.log(config);
  var persistence$1 = /*#__PURE__*/persistence(config.appName || "app");
  return function ($root) {
    var strictMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var r = /*#__PURE__*/createRoot($root);
    var storeValue = /*#__PURE__*/persistence$1.hydrate();
    var store$ = /*#__PURE__*/Store.create(storeValue);
    applyMiddlewares(store$, middlewares);
    var app = /*#__PURE__*/jsx(StoreProvider, {
      value: store$,
      children: /*#__PURE__*/jsxs(ConfigProvider, {
        value: {
          config
        },
        children: [/*#__PURE__*/jsx(PersistenceConnect, {
          persistence: persistence$1
        }), /*#__PURE__*/jsx(React2rxRouter, {
          basename: config.basename,
          children: typeof e === "function" ? e() : e
        })]
      })
    });
    if (strictMode) {
      r.render( /*#__PURE__*/jsx(StrictMode, {
        children: app
      }));
    } else {
      r.render(app);
    }
  };
};

export { createBootstrap };
