import { AsyncStage, Actor, Middleware } from '@react2rx/core';

type LoggerLevel = "log" | "warn" | "error" | "info";
interface Styles {
    title(title: [string, AsyncStage | undefined], time: string, took: number): string[];
    prevState(arg: any): string;
    nextState(arg: any): string;
    error(arg: any, prev: any): string;
    action(actor: Actor): string;
}
interface IndepLevel {
    title(title: string): LoggerLevel;
    prevState(arg: any): LoggerLevel;
    nextState(arg: any): LoggerLevel;
    error(arg: any, prev: any): LoggerLevel;
    action(actor: Actor): LoggerLevel;
}
interface LoggerOptions {
    styles?: Styles;
    level?: LoggerLevel | IndepLevel;
    titleFormatter?(title: [string, AsyncStage | undefined], time: string, took: number): string;
    stateTransformer?(arg: any): any;
    actionTransformer?(arg: Actor): Actor;
    errorTransformer?(arg: any): any;
}

declare const createLogger: (options?: LoggerOptions) => Middleware;

export { createLogger };
